import unittest
import pandas as pd
import numpy as np

from lhcsmapi.analysis.ItCircuitQuery import ItCircuitQuery


class TestItCircuitQuery(unittest.TestCase):
    def test_create_report_analysis_template(self):
        # arrange
        query = ItCircuitQuery('IT', 'RQX.R1')

        # act
        results_act = query.create_report_analysis_template(1535558373560000000)
        results_act['lhcsmapi_version'] = '1.3.226'

        # assert
        results_ref = pd.DataFrame({'Circuit Name': {0: 'RQX.R1'}, 'Date': {0: '2018-08-29'},
                                    'Time': {0: '17:59:33.560'}, 'I_RQX': {0: np.nan}, 'I_RTQX1': {0: np.nan},
                                    'I_RTQX2': {0: np.nan}, 'I_Q1': {0: np.nan}, 'I_Q2': {0: np.nan},
                                    'I_Q3': {0: np.nan}, 'MITTs_DCCT_RQX': {0: np.nan}, 'MITTs_DCCT_RTQX1': {0: np.nan},
                                    'MITTs_DCCT_RTQX2': {0: np.nan}, 'MITTs_Q1': {0: np.nan}, 'MITTs_Q2': {0: np.nan},
                                    'MITTs_Q3': {0: np.nan}, 'Ramp Rate': {0: np.nan}, 'Plateau Duration': {0: np.nan},
                                    'max_I_EARTH_RQX': {0: np.nan}, 'max_I_EARTH_RTQX1': {0: np.nan},
                                    'max_I_EARTH_RTQX2': {0: np.nan}, 'Reason': {0: np.nan},
                                    'Quench Origin': {0: np.nan}, 'dU_RES_dt_Q1': {0: np.nan},
                                    'dU_RES_dt_Q2': {0: np.nan}, 'dU_RES_dt_Q3': {0: np.nan},
                                    'QH': {0: np.nan}, 'performed_by': {0: ''},
                                    'lhcsmapi_version': {0: '1.3.226'}})

        results_act.fillna(np.nan, inplace=True)
        pd.testing.assert_frame_equal(results_ref, results_act)


